/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.116 Revision 1.148
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.116 2011/07/04 11:27:53 djc Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.148 2012/02/10 04:15:42 patrick Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
13if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 14 inherit multilib
15fi
13 16
17# Export pkg_setup every time to avoid issues with eclass inheritance order.
18if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
19 EXPORT_FUNCTIONS pkg_setup
20fi
21
22# Avoid processing this eclass more than once.
23if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
24_PYTHON_ECLASS_INHERITED="1"
25
14if ! has "${EAPI:-0}" 0 1 2 3; then 26if ! has "${EAPI:-0}" 0 1 2 3 4; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 27 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 28fi
17 29
18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 30_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.5 2.6 2.7)
19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.0 3.1 3.2 3.3) 31_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython) 32_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
33_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7)
21_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]}) 34_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
22 35
23# ================================================================================================ 36# ================================================================================================
24# ===================================== HANDLING OF METADATA ===================================== 37# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================ 38# ================================================================================================
39
40_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
26 41
27_python_check_python_abi_matching() { 42_python_check_python_abi_matching() {
28 local pattern patterns patterns_list="0" PYTHON_ABI 43 local pattern patterns patterns_list="0" PYTHON_ABI
29 44
30 while (($#)); do 45 while (($#)); do
56 pattern="$2" 71 pattern="$2"
57 72
58 if [[ "${pattern}" == *"-cpython" ]]; then 73 if [[ "${pattern}" == *"-cpython" ]]; then
59 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]] 74 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
60 elif [[ "${pattern}" == *"-jython" ]]; then 75 elif [[ "${pattern}" == *"-jython" ]]; then
76 [[ "${PYTHON_ABI}" == ${pattern} ]]
77 elif [[ "${pattern}" == *"-pypy-"* ]]; then
61 [[ "${PYTHON_ABI}" == ${pattern} ]] 78 [[ "${PYTHON_ABI}" == ${pattern} ]]
62 else 79 else
63 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 80 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
64 [[ "${PYTHON_ABI}" == ${pattern} ]] 81 [[ "${PYTHON_ABI}" == ${pattern} ]]
65 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 82 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
66 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]] 83 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
84 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
85 [[ "${PYTHON_ABI%-pypy-*}" == ${pattern} ]]
67 else 86 else
68 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'" 87 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
69 fi 88 fi
70 fi 89 fi
71 else 90 else
76 return 0 95 return 0
77 fi 96 fi
78 done <<< "${patterns}" 97 done <<< "${patterns}"
79 98
80 return 1 99 return 1
100 fi
101}
102
103_python_package_supporting_installation_for_multiple_python_abis() {
104 if has "${EAPI:-0}" 0 1 2 3 4; then
105 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
106 return 0
107 else
108 return 1
109 fi
110 else
111 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
81 fi 112 fi
82} 113}
83 114
84# @ECLASS-VARIABLE: PYTHON_DEPEND 115# @ECLASS-VARIABLE: PYTHON_DEPEND
85# @DESCRIPTION: 116# @DESCRIPTION:
278_python_implementation() { 309_python_implementation() {
279 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then 310 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
280 return 0 311 return 0
281 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then 312 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
282 return 0 313 return 0
314 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
315 return 0
283 else 316 else
284 return 1 317 return 1
285 fi
286}
287
288_python_package_supporting_installation_for_multiple_python_abis() {
289 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
290 die "${FUNCNAME}() cannot be used in global scope"
291 fi
292
293 if has "${EAPI:-0}" 0 1 2 3 4; then
294 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
295 return 0
296 else
297 return 1
298 fi
299 else
300 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
301 fi 318 fi
302} 319}
303 320
304_python_abi-specific_local_scope() { 321_python_abi-specific_local_scope() {
305 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]] 322 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
379 _CYAN= 396 _CYAN=
380 _NORMAL= 397 _NORMAL=
381 fi 398 fi
382} 399}
383 400
384unset PYTHON_PKG_SETUP_EXECUTED
385
386_python_check_python_pkg_setup_execution() { 401_python_check_python_pkg_setup_execution() {
387 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return 402 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
388 403
389 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then 404 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
390 die "python_pkg_setup() not called" 405 die "python_pkg_setup() not called"
458 fi 473 fi
459 474
460 PYTHON_PKG_SETUP_EXECUTED="1" 475 PYTHON_PKG_SETUP_EXECUTED="1"
461} 476}
462 477
463if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
464 EXPORT_FUNCTIONS pkg_setup
465fi
466
467_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|python)' 478_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
468 479
469# @FUNCTION: python_convert_shebangs 480# @FUNCTION: python_convert_shebangs
470# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories] 481# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
471# @DESCRIPTION: 482# @DESCRIPTION:
472# Convert shebangs in specified files. Directories can be specified only with --recursive option. 483# Convert shebangs in specified files. Directories can be specified only with --recursive option.
473python_convert_shebangs() { 484python_convert_shebangs() {
474 _python_check_python_pkg_setup_execution 485 _python_check_python_pkg_setup_execution
475 486
476 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" 487 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
477 488
478 while (($#)); do 489 while (($#)); do
479 case "$1" in 490 case "$1" in
480 -r|--recursive) 491 -r|--recursive)
481 recursive="1" 492 recursive="1"
536 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 547 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
537 548
538 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then 549 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
539 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 550 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
540 551
552 shebangs_converted="1"
553
541 if [[ "${quiet}" == "0" ]]; then 554 if [[ "${quiet}" == "0" ]]; then
542 einfo "Converting shebang in '${file}'" 555 einfo "Converting shebang in '${file}'"
543 fi 556 fi
544 557
545 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed" 558 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
559 fi
560 done
561
562 if [[ "${shebangs_converted}" == "0" ]]; then
563 ewarn "${FUNCNAME}(): Python scripts not found"
546 fi 564 fi
565}
566
567# @FUNCTION: python_clean_py-compile_files
568# @USAGE: [-q|--quiet]
569# @DESCRIPTION:
570# Clean py-compile files to disable byte-compilation.
571python_clean_py-compile_files() {
572 _python_check_python_pkg_setup_execution
573
574 local file files=() quiet="0"
575
576 while (($#)); do
577 case "$1" in
578 -q|--quiet)
579 quiet="1"
580 ;;
581 -*)
582 die "${FUNCNAME}(): Unrecognized option '$1'"
583 ;;
584 *)
585 die "${FUNCNAME}(): Invalid usage"
586 ;;
587 esac
588 shift
589 done
590
591 while read -d $'\0' -r file; do
592 files+=("${file#./}")
593 done < <(find -name py-compile -type f -print0)
594
595 for file in "${files[@]}"; do
596 if [[ "${quiet}" == "0" ]]; then
597 einfo "Cleaning '${file}' file"
598 fi
599 echo "#!/bin/sh" > "${file}"
547 done 600 done
548} 601}
549 602
550# @FUNCTION: python_clean_installation_image 603# @FUNCTION: python_clean_installation_image
551# @USAGE: [-q|--quiet] 604# @USAGE: [-q|--quiet]
706 fi 759 fi
707 760
708 _python_initial_sanity_checks 761 _python_initial_sanity_checks
709 762
710 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 763 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
711 local PYTHON_ABI restricted_ABI restricted_ABIs support_ABI supported_PYTHON_ABIS 764 local PYTHON_ABI
712
713 restricted_ABIs="${RESTRICT_PYTHON_ABIS// /$'\n'}"
714 765
715 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 766 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
716 local cpython_enabled="0" 767 local cpython_enabled="0"
717 768
718 if [[ -z "${USE_PYTHON}" ]]; then 769 if [[ -z "${USE_PYTHON}" ]]; then
726 777
727 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then 778 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
728 cpython_enabled="1" 779 cpython_enabled="1"
729 fi 780 fi
730 781
731 support_ABI="1"
732 while read restricted_ABI; do
733 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then 782 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
734 support_ABI="0" 783 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
735 break
736 fi 784 fi
737 done <<< "${restricted_ABIs}"
738 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
739 done 785 done
740 786
741 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then 787 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
742 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}" 788 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
743 fi 789 fi
759 die "'${EPREFIX}/usr/bin/python2' is not valid symlink" 805 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
760 fi 806 fi
761 807
762 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 808 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
763 809
810 support_python_major_version="0"
764 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do 811 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
812 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
765 support_python_major_version="1" 813 support_python_major_version="1"
766 while read restricted_ABI; do 814 break
767 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
768 support_python_major_version="0"
769 fi 815 fi
770 done <<< "${restricted_ABIs}"
771 [[ "${support_python_major_version}" == "1" ]] && break
772 done 816 done
773 if [[ "${support_python_major_version}" == "1" ]]; then 817 if [[ "${support_python_major_version}" == "1" ]]; then
774 while read restricted_ABI; do
775 if _python_check_python_abi_matching "${python2_version}" "${restricted_ABI}"; then 818 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
776 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}" 819 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
777 fi 820 fi
778 done <<< "${restricted_ABIs}"
779 else 821 else
780 python2_version="" 822 python2_version=""
781 fi 823 fi
782 fi 824 fi
783 825
786 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 828 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
787 fi 829 fi
788 830
789 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 831 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
790 832
833 support_python_major_version="0"
791 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do 834 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
835 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
792 support_python_major_version="1" 836 support_python_major_version="1"
793 while read restricted_ABI; do 837 break
794 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
795 support_python_major_version="0"
796 fi 838 fi
797 done <<< "${restricted_ABIs}"
798 [[ "${support_python_major_version}" == "1" ]] && break
799 done 839 done
800 if [[ "${support_python_major_version}" == "1" ]]; then 840 if [[ "${support_python_major_version}" == "1" ]]; then
801 while read restricted_ABI; do
802 if _python_check_python_abi_matching "${python3_version}" "${restricted_ABI}"; then 841 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
803 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}" 842 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
804 fi 843 fi
805 done <<< "${restricted_ABIs}"
806 else 844 else
807 python3_version="" 845 python3_version=""
808 fi 846 fi
809 fi 847 fi
810 848
835 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\"" 873 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
836 for prefix in PYTHON_USER_ PYTHON_; do 874 for prefix in PYTHON_USER_ PYTHON_; do
837 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then 875 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
838 eval "array=(\"\${${prefix}${variable}[@]}\")" 876 eval "array=(\"\${${prefix}${variable}[@]}\")"
839 for element in "${array[@]}"; do 877 for element in "${array[@]}"; do
840 if [[ "${element}" =~ ^([[:alnum:]]|\.|-|\*|\[|\])+\ (\+|-)\ .+ ]]; then 878 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
841 pattern="${element%% *}" 879 pattern="${element%% *}"
842 element="${element#* }" 880 element="${element#* }"
843 operator="${element%% *}" 881 operator="${element%% *}"
844 flags="${element#* }" 882 flags="${element#* }"
845 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then 883 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
1015 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 1053 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
1016 fi 1054 fi
1017 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 1055 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1018 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then 1056 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1019 if [[ "${quiet}" == "0" ]]; then 1057 if [[ "${quiet}" == "0" ]]; then
1020 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version) skipped${_NORMAL}" 1058 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1021 fi 1059 fi
1022 continue 1060 continue
1023 fi 1061 fi
1024 1062
1025 _python_prepare_flags 1063 _python_prepare_flags
1026 1064
1027 if [[ "${quiet}" == "0" ]]; then 1065 if [[ "${quiet}" == "0" ]]; then
1028 if [[ -n "${action_message_template}" ]]; then 1066 if [[ -n "${action_message_template}" ]]; then
1029 eval "action_message=\"${action_message_template}\"" 1067 eval "action_message=\"${action_message_template}\""
1030 else 1068 else
1031 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 1069 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
1032 fi 1070 fi
1033 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 1071 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
1034 fi 1072 fi
1035 1073
1036 if [[ "${separate_build_dirs}" == "1" ]]; then 1074 if [[ "${separate_build_dirs}" == "1" ]]; then
1060 1098
1061 if [[ "${return_code}" -ne 0 ]]; then 1099 if [[ "${return_code}" -ne 0 ]]; then
1062 if [[ -n "${failure_message_template}" ]]; then 1100 if [[ -n "${failure_message_template}" ]]; then
1063 eval "failure_message=\"${failure_message_template}\"" 1101 eval "failure_message=\"${failure_message_template}\""
1064 else 1102 else
1065 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 1103 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
1066 fi 1104 fi
1067 1105
1068 if [[ "${nonfatal}" == "1" ]]; then 1106 if [[ "${nonfatal}" == "1" ]]; then
1069 if [[ "${quiet}" == "0" ]]; then 1107 if [[ "${quiet}" == "0" ]]; then
1070 ewarn "${failure_message}" 1108 ewarn "${failure_message}"
1241import os 1279import os
1242import re 1280import re
1243import subprocess 1281import subprocess
1244import sys 1282import sys
1245 1283
1246cpython_re = re.compile(r"^python(\d+\.\d+)$") 1284cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1285jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1286pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
1287cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1247jython_re = re.compile(r"^jython(\d+\.\d+)$") 1288jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1289pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1248python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)") 1290cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1291python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1249python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1292python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1250 1293
1251def get_PYTHON_ABI(EPYTHON): 1294pypy_versions_mapping = {
1252 cpython_matched = cpython_re.match(EPYTHON) 1295 "1.5": "2.7"
1253 jython_matched = jython_re.match(EPYTHON) 1296}
1297
1298def get_PYTHON_ABI(python_interpreter):
1299 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1300 jython_matched = jython_interpreter_re.match(python_interpreter)
1301 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1254 if cpython_matched is not None: 1302 if cpython_matched is not None:
1255 PYTHON_ABI = cpython_matched.group(1) 1303 PYTHON_ABI = cpython_matched.group(1)
1256 elif jython_matched is not None: 1304 elif jython_matched is not None:
1257 PYTHON_ABI = jython_matched.group(1) + "-jython" 1305 PYTHON_ABI = jython_matched.group(1) + "-jython"
1306 elif pypy_matched is not None:
1307 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1258 else: 1308 else:
1259 PYTHON_ABI = None 1309 PYTHON_ABI = None
1260 return PYTHON_ABI 1310 return PYTHON_ABI
1261 1311
1312def get_python_interpreter(PYTHON_ABI):
1313 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1314 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1315 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1316 if cpython_matched is not None:
1317 python_interpreter = "python" + cpython_matched.group(1)
1318 elif jython_matched is not None:
1319 python_interpreter = "jython" + jython_matched.group(1)
1320 elif pypy_matched is not None:
1321 python_interpreter = "pypy-c" + pypy_matched.group(1)
1322 else:
1323 python_interpreter = None
1324 return python_interpreter
1325
1262EOF 1326EOF
1263 if [[ "$?" != "0" ]]; then 1327 if [[ "$?" != "0" ]]; then
1264 die "${FUNCNAME}(): Generation of '$1' failed" 1328 die "${FUNCNAME}(): Generation of '$1' failed"
1265 fi 1329 fi
1266 if [[ "${respect_EPYTHON}" == "1" ]]; then 1330 if [[ "${respect_EPYTHON}" == "1" ]]; then
1267 cat << EOF >> "${file}" 1331 cat << EOF >> "${file}"
1268EPYTHON = os.environ.get("EPYTHON") 1332python_interpreter = os.environ.get("EPYTHON")
1269if EPYTHON: 1333if python_interpreter:
1270 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1334 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1271 if PYTHON_ABI is None: 1335 if PYTHON_ABI is None:
1272 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1336 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1273 sys.exit(1) 1337 sys.exit(1)
1274else: 1338else:
1275 try: 1339 try:
1340 environment = os.environ.copy()
1341 environment["ROOT"] = "/"
1276 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1342 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1277 if eselect_process.wait() != 0: 1343 if eselect_process.wait() != 0:
1278 raise ValueError 1344 raise ValueError
1279 except (OSError, ValueError): 1345 except (OSError, ValueError):
1280 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1346 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1281 sys.exit(1) 1347 sys.exit(1)
1282 1348
1283 EPYTHON = eselect_process.stdout.read() 1349 python_interpreter = eselect_process.stdout.read()
1284 if not isinstance(EPYTHON, str): 1350 if not isinstance(python_interpreter, str):
1285 # Python 3 1351 # Python 3
1286 EPYTHON = EPYTHON.decode() 1352 python_interpreter = python_interpreter.decode()
1287 EPYTHON = EPYTHON.rstrip("\n") 1353 python_interpreter = python_interpreter.rstrip("\n")
1288 1354
1289 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1355 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1290 if PYTHON_ABI is None: 1356 if PYTHON_ABI is None:
1291 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1357 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1292 sys.exit(1) 1358 sys.exit(1)
1293 1359
1294wrapper_script_path = os.path.realpath(sys.argv[0]) 1360wrapper_script_path = os.path.realpath(sys.argv[0])
1295target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1361target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1296if not os.path.exists(target_executable_path): 1362if not os.path.exists(target_executable_path):
1297 sys.stderr.write("'%s' does not exist\n" % target_executable_path) 1363 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
1298 sys.exit(1) 1364 sys.exit(1)
1299EOF 1365EOF
1300 if [[ "$?" != "0" ]]; then 1366 if [[ "$?" != "0" ]]; then
1301 die "${FUNCNAME}(): Generation of '$1' failed" 1367 die "${FUNCNAME}(): Generation of '$1' failed"
1302 fi 1368 fi
1303 else 1369 else
1304 cat << EOF >> "${file}" 1370 cat << EOF >> "${file}"
1305try: 1371try:
1372 environment = os.environ.copy()
1373 environment["ROOT"] = "/"
1306 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1374 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1307 if eselect_process.wait() != 0: 1375 if eselect_process.wait() != 0:
1308 raise ValueError 1376 raise ValueError
1309except (OSError, ValueError): 1377except (OSError, ValueError):
1310 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1378 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1311 sys.exit(1) 1379 sys.exit(1)
1312 1380
1313EPYTHON = eselect_process.stdout.read() 1381python_interpreter = eselect_process.stdout.read()
1314if not isinstance(EPYTHON, str): 1382if not isinstance(python_interpreter, str):
1315 # Python 3 1383 # Python 3
1316 EPYTHON = EPYTHON.decode() 1384 python_interpreter = python_interpreter.decode()
1317EPYTHON = EPYTHON.rstrip("\n") 1385python_interpreter = python_interpreter.rstrip("\n")
1318 1386
1319PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1387PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1320if PYTHON_ABI is None: 1388if PYTHON_ABI is None:
1321 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1389 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1322 sys.exit(1) 1390 sys.exit(1)
1323 1391
1324wrapper_script_path = os.path.realpath(sys.argv[0]) 1392wrapper_script_path = os.path.realpath(sys.argv[0])
1325for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]: 1393for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1326 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1394 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1327 if os.path.exists(target_executable_path): 1395 if os.path.exists(target_executable_path):
1328 break 1396 break
1329else: 1397else:
1330 sys.stderr.write("No target script exists for '%s'\n" % wrapper_script_path) 1398 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1399 sys.exit(1)
1400
1401python_interpreter = get_python_interpreter(PYTHON_ABI)
1402if python_interpreter is None:
1403 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1331 sys.exit(1) 1404 sys.exit(1)
1332EOF 1405EOF
1333 if [[ "$?" != "0" ]]; then 1406 if [[ "$?" != "0" ]]; then
1334 die "${FUNCNAME}(): Generation of '$1' failed" 1407 die "${FUNCNAME}(): Generation of '$1' failed"
1335 fi 1408 fi
1336 fi 1409 fi
1337 cat << EOF >> "${file}" 1410 cat << EOF >> "${file}"
1338 1411
1339target_executable = open(target_executable_path, "rb") 1412target_executable = open(target_executable_path, "rb")
1340target_executable_first_line = target_executable.readline() 1413target_executable_first_line = target_executable.readline()
1414target_executable.close()
1341if not isinstance(target_executable_first_line, str): 1415if not isinstance(target_executable_first_line, str):
1342 # Python 3 1416 # Python 3
1343 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace") 1417 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1344 1418
1419options = []
1420python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1421if python_shebang_options_matched is not None:
1422 options = [python_shebang_options_matched.group(1)]
1423
1345python_shebang_matched = python_shebang_re.match(target_executable_first_line) 1424cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1346target_executable.close()
1347 1425
1348if python_shebang_matched is not None: 1426if cpython_shebang_matched is not None:
1349 try: 1427 try:
1350 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON 1428 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1351 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1" 1429 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1352 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE) 1430 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1353 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1431 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1354 if python_verification_process.wait() != 0: 1432 if python_verification_process.wait() != 0:
1355 raise ValueError 1433 raise ValueError
1360 python_verification_output = python_verification_output.decode() 1438 python_verification_output = python_verification_output.decode()
1361 1439
1362 if not python_verification_output_re.match(python_verification_output): 1440 if not python_verification_output_re.match(python_verification_output):
1363 raise ValueError 1441 raise ValueError
1364 1442
1365 if cpython_re.match(EPYTHON) is not None: 1443 if cpython_interpreter_re.match(python_interpreter) is not None:
1366 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0]) 1444 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1367 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0] 1445 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1368 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path 1446 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1369 1447
1370 if hasattr(os, "execv"): 1448 if hasattr(os, "execv"):
1371 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv) 1449 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1372 else: 1450 else:
1373 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait()) 1451 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1374 except (KeyboardInterrupt, SystemExit): 1452 except (KeyboardInterrupt, SystemExit):
1375 raise 1453 raise
1376 except: 1454 except:
1377 pass 1455 pass
1378 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"): 1456 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1420 fi 1498 fi
1421 1499
1422 _python_check_python_pkg_setup_execution 1500 _python_check_python_pkg_setup_execution
1423 _python_initialize_prefix_variables 1501 _python_initialize_prefix_variables
1424 1502
1425 local b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=() 1503 local absolute_file b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1426 1504
1427 while (($#)); do 1505 while (($#)); do
1428 case "$1" in 1506 case "$1" in
1429 -q|--quiet) 1507 -q|--quiet)
1430 quiet="1" 1508 quiet="1"
1512 break 1590 break
1513 fi 1591 fi
1514 done 1592 done
1515 fi 1593 fi
1516 1594
1517 [[ "${version_executable}" == "0" || ! -x "${file}" ]] && continue 1595 [[ "${version_executable}" == "0" ]] && continue
1518 1596
1597 if [[ -L "${file}" ]]; then
1598 absolute_file="$(readlink "${file}")"
1599 if [[ "${absolute_file}" == /* ]]; then
1600 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file##/}"
1601 else
1602 if [[ "${file}" == */* ]]; then
1603 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file%/*}/${absolute_file}"
1604 else
1605 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file}"
1606 fi
1607 fi
1608 else
1609 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file}"
1610 fi
1611
1612 [[ ! -x "${absolute_file}" ]] && continue
1613
1519 shebang="$(head -n1 "${file}")" || die "Extraction of shebang from '${file}' failed" 1614 shebang="$(head -n1 "${absolute_file}")" || die "Extraction of shebang from '${absolute_file}' failed"
1520 1615
1521 if [[ "${version_executable}" == "2" ]]; then 1616 if [[ "${version_executable}" == "2" ]]; then
1522 wrapper_scripts+=("${ED}${file}") 1617 wrapper_scripts+=("${ED}${file}")
1523 elif [[ "${version_executable}" == "1" ]]; then 1618 elif [[ "${version_executable}" == "1" ]]; then
1524 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then 1619 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1535 fi 1630 fi
1536 1631
1537 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed" 1632 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1538 1633
1539 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then 1634 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1635 if [[ -L "${file}-${PYTHON_ABI}" ]]; then
1636 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${absolute_file}"
1637 else
1540 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}" 1638 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1639 fi
1541 fi 1640 fi
1542 done 1641 done
1543 1642
1544 popd > /dev/null || die "popd failed" 1643 popd > /dev/null || die "popd failed"
1545 1644
1645 # This is per bug #390691, without the duplication refactor, and with
1646 # the 3-way structure per comment #6. This enable users with old
1647 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1648 # before coreutils can be upgraded).
1649 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1650 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1546 if ROOT="/" has_version sys-apps/coreutils; then 1651 elif ROOT="/" has_version sys-apps/coreutils; then
1547 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1652 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1548 else 1653 else
1549 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1654 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1550 fi 1655 fi
1551 done 1656 done
1570 stdout = sys.stdout.buffer 1675 stdout = sys.stdout.buffer
1571else: 1676else:
1572 # Python 2 1677 # Python 2
1573 stdout = sys.stdout 1678 stdout = sys.stdout
1574 1679
1680python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1575files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00')) 1681files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1682python_wrapper_scripts_file.close()
1576 1683
1577for file in sorted(files): 1684for file in sorted(files):
1578 stdout.write(file) 1685 stdout.write(file)
1579 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts") 1686 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1580 1687
1645 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1752 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1646 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1753 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1647} 1754}
1648 1755
1649# @FUNCTION: python_need_rebuild 1756# @FUNCTION: python_need_rebuild
1757# @DESCRIPTION:
1650# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1758# Mark current package for rebuilding by python-updater after
1651# switching of active version of Python. 1759# switching of active version of Python.
1652python_need_rebuild() { 1760python_need_rebuild() {
1653 if _python_package_supporting_installation_for_multiple_python_abis; then 1761 if _python_package_supporting_installation_for_multiple_python_abis; then
1654 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1762 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1655 fi 1763 fi
1665 1773
1666# ================================================================================================ 1774# ================================================================================================
1667# ======================================= GETTER FUNCTIONS ======================================= 1775# ======================================= GETTER FUNCTIONS =======================================
1668# ================================================================================================ 1776# ================================================================================================
1669 1777
1670_PYTHON_ABI_EXTRACTION_COMMAND='import platform 1778_PYTHON_ABI_EXTRACTION_COMMAND=\
1779'import platform
1671import sys 1780import sys
1672sys.stdout.write(".".join(str(x) for x in sys.version_info[:2])) 1781sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1673if platform.system()[:4] == "Java": 1782if platform.system()[:4] == "Java":
1674 sys.stdout.write("-jython")' 1783 sys.stdout.write("-jython")
1784elif hasattr(platform, "python_implementation") and platform.python_implementation() == "PyPy":
1785 sys.stdout.write("-pypy-" + ".".join(str(x) for x in sys.pypy_version_info[:2]))'
1675 1786
1676_python_get_implementation() { 1787_python_get_implementation() {
1677 local ignore_invalid="0" 1788 local ignore_invalid="0"
1678 1789
1679 while (($#)); do 1790 while (($#)); do
1701 1812
1702 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1813 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1703 echo "CPython" 1814 echo "CPython"
1704 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 1815 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1705 echo "Jython" 1816 echo "Jython"
1817 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1818 echo "PyPy"
1706 else 1819 else
1707 if [[ "${ignore_invalid}" == "0" ]]; then 1820 if [[ "${ignore_invalid}" == "0" ]]; then
1708 die "${FUNCNAME}(): Unrecognized Python ABI '$1'" 1821 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1709 fi 1822 fi
1710 fi 1823 fi
1773 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1886 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1774 fi 1887 fi
1775 _python_calculate_PYTHON_ABIS 1888 _python_calculate_PYTHON_ABIS
1776 PYTHON_ABI="${PYTHON_ABIS##* }" 1889 PYTHON_ABI="${PYTHON_ABIS##* }"
1777 elif [[ "${python2}" == "1" ]]; then 1890 elif [[ "${python2}" == "1" ]]; then
1778 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1891 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1779 if [[ -z "${PYTHON_ABI}" ]]; then 1892 if [[ -z "${PYTHON_ABI}" ]]; then
1780 die "${FUNCNAME}(): Active version of CPython 2 not set" 1893 die "${FUNCNAME}(): Active version of CPython 2 not set"
1781 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1894 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1782 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1895 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1783 fi 1896 fi
1784 elif [[ "${python3}" == "1" ]]; then 1897 elif [[ "${python3}" == "1" ]]; then
1785 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1898 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1786 if [[ -z "${PYTHON_ABI}" ]]; then 1899 if [[ -z "${PYTHON_ABI}" ]]; then
1787 die "${FUNCNAME}(): Active version of CPython 3 not set" 1900 die "${FUNCNAME}(): Active version of CPython 3 not set"
1788 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1901 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1789 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1902 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1790 fi 1903 fi
1819 else 1932 else
1820 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1933 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1821 python_interpreter="python${PYTHON_ABI}" 1934 python_interpreter="python${PYTHON_ABI}"
1822 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1935 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1823 python_interpreter="jython${PYTHON_ABI%-jython}" 1936 python_interpreter="jython${PYTHON_ABI%-jython}"
1937 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1938 python_interpreter="pypy-c${PYTHON_ABI#*-pypy-}"
1824 fi 1939 fi
1825 1940
1826 if [[ "${absolute_path_output}" == "1" ]]; then 1941 if [[ "${absolute_path_output}" == "1" ]]; then
1827 echo -n "${EPREFIX}/usr/bin/${python_interpreter}" 1942 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1828 else 1943 else
1921 if [[ "${EAPI:-0}" == "0" ]]; then 2036 if [[ "${EAPI:-0}" == "0" ]]; then
1922 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2037 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1923 echo "=dev-lang/python-${PYTHON_ABI}*" 2038 echo "=dev-lang/python-${PYTHON_ABI}*"
1924 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2039 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1925 echo "=dev-java/jython-${PYTHON_ABI%-jython}*" 2040 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
2041 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2042 echo "=dev-python/pypy-${PYTHON_ABI#*-pypy-}*"
1926 fi 2043 fi
1927 else 2044 else
1928 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2045 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1929 echo "dev-lang/python:${PYTHON_ABI}" 2046 echo "dev-lang/python:${PYTHON_ABI}"
1930 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2047 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1931 echo "dev-java/jython:${PYTHON_ABI%-jython}" 2048 echo "dev-java/jython:${PYTHON_ABI%-jython}"
2049 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2050 echo "dev-python/pypy:${PYTHON_ABI#*-pypy-}"
1932 fi 2051 fi
1933 fi 2052 fi
1934} 2053}
1935 2054
1936# @FUNCTION: python_get_includedir 2055# @FUNCTION: python_get_includedir
1983 2102
1984 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2103 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1985 echo "${prefix}usr/include/python${PYTHON_ABI}" 2104 echo "${prefix}usr/include/python${PYTHON_ABI}"
1986 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2105 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1987 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include" 2106 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
2107 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2108 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/include"
1988 fi 2109 fi
1989} 2110}
1990 2111
1991# @FUNCTION: python_get_libdir 2112# @FUNCTION: python_get_libdir
1992# @USAGE: [-b|--base-path] [-f|--final-ABI] 2113# @USAGE: [-b|--base-path] [-f|--final-ABI]
1993# @DESCRIPTION: 2114# @DESCRIPTION:
1994# Print path to Python library directory. 2115# Print path to Python standard library directory.
1995# If --base-path option is specified, then path not prefixed with "/" is printed. 2116# If --base-path option is specified, then path not prefixed with "/" is printed.
1996# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2117# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1997python_get_libdir() { 2118python_get_libdir() {
1998 _python_check_python_pkg_setup_execution 2119 _python_check_python_pkg_setup_execution
1999 2120
2038 2159
2039 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2160 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2040 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}" 2161 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2041 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2162 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2042 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib" 2163 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2164 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2165 die "${FUNCNAME}(): PyPy has multiple standard library directories"
2043 fi 2166 fi
2044} 2167}
2045 2168
2046# @FUNCTION: python_get_sitedir 2169# @FUNCTION: python_get_sitedir
2047# @USAGE: [-b|--base-path] [-f|--final-ABI] 2170# @USAGE: [-b|--base-path] [-f|--final-ABI]
2050# If --base-path option is specified, then path not prefixed with "/" is printed. 2173# If --base-path option is specified, then path not prefixed with "/" is printed.
2051# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2174# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2052python_get_sitedir() { 2175python_get_sitedir() {
2053 _python_check_python_pkg_setup_execution 2176 _python_check_python_pkg_setup_execution
2054 2177
2055 local final_ABI="0" options=() 2178 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2056 2179
2057 while (($#)); do 2180 while (($#)); do
2058 case "$1" in 2181 case "$1" in
2059 -b|--base-path) 2182 -b|--base-path)
2060 options+=("$1") 2183 base_path="1"
2061 ;; 2184 ;;
2062 -f|--final-ABI) 2185 -f|--final-ABI)
2063 final_ABI="1" 2186 final_ABI="1"
2064 options+=("$1")
2065 ;; 2187 ;;
2066 -*) 2188 -*)
2067 die "${FUNCNAME}(): Unrecognized option '$1'" 2189 die "${FUNCNAME}(): Unrecognized option '$1'"
2068 ;; 2190 ;;
2069 *) 2191 *)
2070 die "${FUNCNAME}(): Invalid usage" 2192 die "${FUNCNAME}(): Invalid usage"
2071 ;; 2193 ;;
2072 esac 2194 esac
2073 shift 2195 shift
2074 done 2196 done
2197
2198 if [[ "${base_path}" == "0" ]]; then
2199 prefix="/"
2200 fi
2075 2201
2076 if [[ "${final_ABI}" == "1" ]]; then 2202 if [[ "${final_ABI}" == "1" ]]; then
2077 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2203 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2078 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2204 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2079 fi 2205 fi
2206 PYTHON_ABI="$(PYTHON -f --ABI)"
2080 else 2207 else
2081 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2208 if _python_package_supporting_installation_for_multiple_python_abis; then
2209 if ! _python_abi-specific_local_scope; then
2082 die "${FUNCNAME}() should be used in ABI-specific local scope" 2210 die "${FUNCNAME}() should be used in ABI-specific local scope"
2083 fi 2211 fi
2212 else
2213 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2084 fi 2214 fi
2215 fi
2085 2216
2086 echo "$(python_get_libdir "${options[@]}")/site-packages" 2217 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2218 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}/site-packages"
2219 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2220 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib/site-packages"
2221 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2222 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/site-packages"
2223 fi
2087} 2224}
2088 2225
2089# @FUNCTION: python_get_library 2226# @FUNCTION: python_get_library
2090# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option] 2227# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2091# @DESCRIPTION: 2228# @DESCRIPTION:
2148 else 2285 else
2149 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 2286 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2150 fi 2287 fi
2151 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2288 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2152 die "${FUNCNAME}(): Jython does not have shared library" 2289 die "${FUNCNAME}(): Jython does not have shared library"
2290 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2291 die "${FUNCNAME}(): PyPy does not have shared library"
2153 fi 2292 fi
2154} 2293}
2155 2294
2156# @FUNCTION: python_get_version 2295# @FUNCTION: python_get_version
2157# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro] 2296# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2158# @DESCRIPTION: 2297# @DESCRIPTION:
2159# Print Python version. 2298# Print version of Python implementation.
2160# --full, --major, --minor and --micro options cannot be specified simultaneously. 2299# --full, --major, --minor and --micro options cannot be specified simultaneously.
2161# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 2300# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2301# If --language option is specified, then version of Python language is printed.
2302# --language and --full options cannot be specified simultaneously.
2303# --language and --micro options cannot be specified simultaneously.
2162# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2304# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2163python_get_version() { 2305python_get_version() {
2164 _python_check_python_pkg_setup_execution 2306 _python_check_python_pkg_setup_execution
2165 2307
2166 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command 2308 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
2167 2309
2168 while (($#)); do 2310 while (($#)); do
2169 case "$1" in 2311 case "$1" in
2170 -f|--final-ABI) 2312 -f|--final-ABI)
2171 final_ABI="1" 2313 final_ABI="1"
2172 ;; 2314 ;;
2315 -l|--language)
2316 language="1"
2317 ;;
2173 --full) 2318 --full)
2174 full="1" 2319 full="1"
2175 ;; 2320 ;;
2176 --major) 2321 --major)
2177 major="1" 2322 major="1"
2189 die "${FUNCNAME}(): Invalid usage" 2334 die "${FUNCNAME}(): Invalid usage"
2190 ;; 2335 ;;
2191 esac 2336 esac
2192 shift 2337 shift
2193 done 2338 done
2194
2195 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2196 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2197 fi
2198
2199 if [[ "${full}" == "1" ]]; then
2200 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
2201 elif [[ "${major}" == "1" ]]; then
2202 python_command="from sys import version_info; print(version_info[0])"
2203 elif [[ "${minor}" == "1" ]]; then
2204 python_command="from sys import version_info; print(version_info[1])"
2205 elif [[ "${micro}" == "1" ]]; then
2206 python_command="from sys import version_info; print(version_info[2])"
2207 else
2208 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2209 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2210 echo "${PYTHON_ABI}"
2211 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2212 echo "${PYTHON_ABI%-jython}"
2213 fi
2214 return
2215 fi
2216 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2217 fi
2218 2339
2219 if [[ "${final_ABI}" == "1" ]]; then 2340 if [[ "${final_ABI}" == "1" ]]; then
2220 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2341 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2221 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2342 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2222 fi 2343 fi
2223 "$(PYTHON -f)" -c "${python_command}"
2224 else 2344 else
2225 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2345 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2226 die "${FUNCNAME}() should be used in ABI-specific local scope" 2346 die "${FUNCNAME}() should be used in ABI-specific local scope"
2227 fi 2347 fi
2348 fi
2349
2350 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2351 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2352 fi
2353
2354 if [[ "${language}" == "1" ]]; then
2355 if [[ "${final_ABI}" == "1" ]]; then
2356 PYTHON_ABI="$(PYTHON -f --ABI)"
2357 elif [[ -z "${PYTHON_ABI}" ]]; then
2358 PYTHON_ABI="$(PYTHON --ABI)"
2359 fi
2360 language_version="${PYTHON_ABI%%-*}"
2361 if [[ "${full}" == "1" ]]; then
2362 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
2363 elif [[ "${major}" == "1" ]]; then
2364 echo "${language_version%.*}"
2365 elif [[ "${minor}" == "1" ]]; then
2366 echo "${language_version#*.}"
2367 elif [[ "${micro}" == "1" ]]; then
2368 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
2369 else
2370 echo "${language_version}"
2371 fi
2372 else
2373 if [[ "${full}" == "1" ]]; then
2374 python_command="import sys; print('.'.join(str(x) for x in getattr(sys, 'pypy_version_info', sys.version_info)[:3]))"
2375 elif [[ "${major}" == "1" ]]; then
2376 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[0])"
2377 elif [[ "${minor}" == "1" ]]; then
2378 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[1])"
2379 elif [[ "${micro}" == "1" ]]; then
2380 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[2])"
2381 else
2382 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2383 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2384 echo "${PYTHON_ABI}"
2385 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2386 echo "${PYTHON_ABI%-jython}"
2387 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2388 echo "${PYTHON_ABI#*-pypy-}"
2389 fi
2390 return
2391 fi
2392 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2393 fi
2394
2395 if [[ "${final_ABI}" == "1" ]]; then
2396 "$(PYTHON -f)" -c "${python_command}"
2397 else
2228 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}" 2398 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2399 fi
2400 fi
2401}
2402
2403# @FUNCTION: python_get_implementation_and_version
2404# @USAGE: [-f|--final-ABI]
2405# @DESCRIPTION:
2406# Print name and version of Python implementation.
2407# If version of Python implementation is not bound to version of Python language, then
2408# version of Python language is additionally printed.
2409# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2410python_get_implementation_and_version() {
2411 _python_check_python_pkg_setup_execution
2412
2413 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
2414
2415 while (($#)); do
2416 case "$1" in
2417 -f|--final-ABI)
2418 final_ABI="1"
2419 ;;
2420 -*)
2421 die "${FUNCNAME}(): Unrecognized option '$1'"
2422 ;;
2423 *)
2424 die "${FUNCNAME}(): Invalid usage"
2425 ;;
2426 esac
2427 shift
2428 done
2429
2430 if [[ "${final_ABI}" == "1" ]]; then
2431 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2432 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2433 fi
2434 PYTHON_ABI="$(PYTHON -f --ABI)"
2435 else
2436 if _python_package_supporting_installation_for_multiple_python_abis; then
2437 if ! _python_abi-specific_local_scope; then
2438 die "${FUNCNAME}() should be used in ABI-specific local scope"
2439 fi
2440 else
2441 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2442 fi
2443 fi
2444
2445 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
2446 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
2447 else
2448 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
2229 fi 2449 fi
2230} 2450}
2231 2451
2232# ================================================================================================ 2452# ================================================================================================
2233# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2453# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
2242_python_test_hook() { 2462_python_test_hook() {
2243 if [[ "$#" -ne 1 ]]; then 2463 if [[ "$#" -ne 1 ]]; then
2244 die "${FUNCNAME}() requires 1 argument" 2464 die "${FUNCNAME}() requires 1 argument"
2245 fi 2465 fi
2246 2466
2247 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then 2467 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
2248 "${FUNCNAME[3]}_$1_hook" 2468 "${_PYTHON_TEST_FUNCTION}_$1_hook"
2249 fi 2469 fi
2250} 2470}
2251 2471
2252# @FUNCTION: python_execute_nosetests 2472# @FUNCTION: python_execute_nosetests
2253# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2473# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2287 python_test_function() { 2507 python_test_function() {
2288 local evaluated_PYTHONPATH 2508 local evaluated_PYTHONPATH
2289 2509
2290 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2510 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2291 2511
2292 _python_test_hook pre 2512 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
2293 2513
2294 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2514 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2295 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2515 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2296 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2516 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2297 else 2517 else
2298 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2518 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2299 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2519 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2300 fi 2520 fi
2301 2521
2302 _python_test_hook post 2522 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
2303 } 2523 }
2304 if _python_package_supporting_installation_for_multiple_python_abis; then 2524 if _python_package_supporting_installation_for_multiple_python_abis; then
2305 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2525 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2306 else 2526 else
2307 if [[ -n "${separate_build_dirs}" ]]; then 2527 if [[ -n "${separate_build_dirs}" ]]; then
2351 python_test_function() { 2571 python_test_function() {
2352 local evaluated_PYTHONPATH 2572 local evaluated_PYTHONPATH
2353 2573
2354 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2574 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2355 2575
2356 _python_test_hook pre 2576 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
2357 2577
2358 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2578 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2359 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2579 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2360 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?" 2580 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2361 else 2581 else
2362 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL} 2582 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2363 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?" 2583 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
2364 fi 2584 fi
2365 2585
2366 _python_test_hook post 2586 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
2367 } 2587 }
2368 if _python_package_supporting_installation_for_multiple_python_abis; then 2588 if _python_package_supporting_installation_for_multiple_python_abis; then
2369 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2589 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2370 else 2590 else
2371 if [[ -n "${separate_build_dirs}" ]]; then 2591 if [[ -n "${separate_build_dirs}" ]]; then
2415 python_test_function() { 2635 python_test_function() {
2416 local evaluated_PYTHONPATH 2636 local evaluated_PYTHONPATH
2417 2637
2418 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2638 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2419 2639
2420 _python_test_hook pre 2640 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
2421 2641
2422 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2642 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2423 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2643 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2424 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2644 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2425 else 2645 else
2426 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2646 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2427 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2647 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2428 fi 2648 fi
2429 2649
2430 _python_test_hook post 2650 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
2431 } 2651 }
2432 if _python_package_supporting_installation_for_multiple_python_abis; then 2652 if _python_package_supporting_installation_for_multiple_python_abis; then
2433 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2653 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2434 else 2654 else
2435 if [[ -n "${separate_build_dirs}" ]]; then 2655 if [[ -n "${separate_build_dirs}" ]]; then
2579 _python_check_python_pkg_setup_execution 2799 _python_check_python_pkg_setup_execution
2580 _python_initialize_prefix_variables 2800 _python_initialize_prefix_variables
2581 2801
2582 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then 2802 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2583 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs. 2803 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2584 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() 2804 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
2585 2805
2586 if _python_package_supporting_installation_for_multiple_python_abis; then 2806 if _python_package_supporting_installation_for_multiple_python_abis; then
2587 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then 2807 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2588 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called" 2808 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2589 fi 2809 fi
2684 options+=("-q") 2904 options+=("-q")
2685 2905
2686 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2906 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2687 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then 2907 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
2688 return_code="0" 2908 return_code="0"
2909 stderr=""
2689 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2910 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2690 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then 2911 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
2691 for dir in "${site_packages_dirs[@]}"; do 2912 for dir in "${site_packages_dirs[@]}"; do
2692 dirs+=("${root}$(python_get_sitedir)/${dir}") 2913 dirs+=("${root}$(python_get_sitedir)/${dir}")
2693 done 2914 done
2694 for dir in "${evaluated_dirs[@]}"; do 2915 for dir in "${evaluated_dirs[@]}"; do
2695 eval "dirs+=(\"\${root}${dir}\")" 2916 eval "dirs+=(\"\${root}${dir}\")"
2696 done 2917 done
2697 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" || return_code="1" 2918 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2698 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2919 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2699 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1" 2920 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
2700 fi 2921 fi
2701 _python_clean_compiled_modules "${dirs[@]}" 2922 _python_clean_compiled_modules "${dirs[@]}"
2702 fi 2923 fi
2703 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then 2924 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
2704 for file in "${site_packages_files[@]}"; do 2925 for file in "${site_packages_files[@]}"; do
2705 files+=("${root}$(python_get_sitedir)/${file}") 2926 files+=("${root}$(python_get_sitedir)/${file}")
2706 done 2927 done
2707 for file in "${evaluated_files[@]}"; do 2928 for file in "${evaluated_files[@]}"; do
2708 eval "files+=(\"\${root}${file}\")" 2929 eval "files+=(\"\${root}${file}\")"
2709 done 2930 done
2710 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" || return_code="1" 2931 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2711 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2932 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2712 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1" 2933 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2713 fi 2934 fi
2714 _python_clean_compiled_modules "${files[@]}" 2935 _python_clean_compiled_modules "${files[@]}"
2715 fi 2936 fi
2716 eend "${return_code}" 2937 eend "${return_code}"
2938 if [[ -n "${stderr}" ]]; then
2939 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2940 while read stderr_line; do
2941 eerror " ${stderr_line}"
2942 done <<< "${stderr}"
2943 fi
2717 fi 2944 fi
2718 unset dirs files 2945 unset dirs files
2719 done 2946 done
2720 2947
2721 if _python_package_supporting_installation_for_multiple_python_abis; then 2948 if _python_package_supporting_installation_for_multiple_python_abis; then
2727 fi 2954 fi
2728 fi 2955 fi
2729 2956
2730 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2957 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
2731 return_code="0" 2958 return_code="0"
2959 stderr=""
2732 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2960 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
2733 if ((${#other_dirs[@]})); then 2961 if ((${#other_dirs[@]})); then
2734 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2962 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2735 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2963 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2736 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2964 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2737 fi 2965 fi
2738 _python_clean_compiled_modules "${other_dirs[@]}" 2966 _python_clean_compiled_modules "${other_dirs[@]}"
2739 fi 2967 fi
2740 if ((${#other_files[@]})); then 2968 if ((${#other_files[@]})); then
2741 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2969 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
2742 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2970 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2743 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2971 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2744 fi 2972 fi
2745 _python_clean_compiled_modules "${other_files[@]}" 2973 _python_clean_compiled_modules "${other_files[@]}"
2746 fi 2974 fi
2747 eend "${return_code}" 2975 eend "${return_code}"
2976 if [[ -n "${stderr}" ]]; then
2977 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2978 while read stderr_line; do
2979 eerror " ${stderr_line}"
2980 done <<< "${stderr}"
2981 fi
2748 fi 2982 fi
2749 else 2983 else
2750 # Deprecated part of python_mod_optimize() 2984 # Deprecated part of python_mod_optimize()
2751 ewarn 2985 ewarn
2752 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation" 2986 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2928} 3162}
2929 3163
2930# ================================================================================================ 3164# ================================================================================================
2931# ===================================== DEPRECATED FUNCTIONS ===================================== 3165# ===================================== DEPRECATED FUNCTIONS =====================================
2932# ================================================================================================ 3166# ================================================================================================
3167
3168fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.116  
changed lines
  Added in v.1.148

  ViewVC Help
Powered by ViewVC 1.1.20